/*
  ____   __   __     _      ____   __   __  _   _   ____    _   _   _  __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / / | | | | / ___|  | | | | | |/ /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /  | | | | \___ \  | |_| | | ' /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |   | |_| |  ___) | |  _  | | . \   / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|    \___/  |____/  |_| |_| |_|\_\ /_/   \_\
                                                                                   
  ____   __   __     _      ____   __   __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |    / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|   /_/   \_\
                                                    
  _____   ____    ___   _____   _____   ____  
 | ____| |  _ \  |_ _| |_   _| | ____| |  _ \ 
 |  _|   | | | |  | |    | |   |  _|   | | | |
 | |___  | |_| |  | |    | |   | |___  | |_| |
 |_____| |____/  |___|   |_|   |_____| |____/ 
                                              
*/
using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;
using UnityEngine.UI;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static bool Done = false;
		public static string MapModName = "";
		public static string MapName = "Tunnels5";
		public static Sprite CustomSprite4 = ModAPI.LoadSprite("CustomSprite4.png");
        public static Sprite CustomSprite5 = ModAPI.LoadSprite("CustomSprite5.png");
        public static Sprite CustomSprite6 = ModAPI.LoadSprite("CustomSprite6.png");
        public static Sprite CustomSprite7 = ModAPI.LoadSprite("CustomSprite7.png");
        public static Sprite CustomSprite8 = ModAPI.LoadSprite("CustomSprite8.png");
        public static Sprite CustomSprite9 = ModAPI.LoadSprite("CustomSprite9.png");
        

		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void OnLoad()
		{
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
			// 
			Map MapMod = ScriptableObject.CreateInstance<Map>();
			MapMod.name = MapName;
			MapMod.UniqueIdentity = Guid.NewGuid().ToString();
			MapMod.Description = "Map";
			MapMod.Thumbnail = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Preview = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Prefab = MapRegistry.GetAllMaps().ElementAt(2).Prefab;
			MapModName = MapMod.name;
			MapRegistry.Register(MapMod);
		}

		public static void RemoveBorders()
		{
			foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
			{
				if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
				{
					Destroy(render.gameObject);
				}
			}

			Map eggs = Resources.Load<Map>("Maps/Humongous");
			foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
			{
				Destroy(light.gameObject);
			}
			var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
			thing.transform.position = new Vector2(500f, 100f);
			thing.transform.localScale = new Vector2(100000f, 100000f);
			thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
			thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
			if (GameObject.Find("Panels"))
			{
				GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
			}
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			if (NoCollision)
			{
				foreach (var col in NewGameobject.GetComponents<Collider2D>())
				{
					col.enabled = false;
				}
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
		{
			GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity);
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (!FacingRight)
			{
				NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
			}
			if (Frozen)
			{
				NewGameobject.AddComponent<TestDelay>();
			}
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
			light.gameObject.tag = "NoClear";
		}

		public static void CreateBackground(String Name, Color32 color, Sprite spritey, bool IsTexture)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = new Vector2(572.314f, 496.2918f);
			var whitespace = Texture2D.whiteTexture;
			whitespace.Resize(16, 16);
			whitespace.Apply();
			if (IsTexture == true)
			{
				var croppedTexture = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				var pixels = spritey.texture.GetPixels((int)spritey.textureRect.x,
														(int)spritey.textureRect.y,
														(int)spritey.textureRect.width,
														(int)spritey.textureRect.height);
				croppedTexture.SetPixels(pixels);
				croppedTexture.wrapMode = TextureWrapMode.Repeat;
				croppedTexture.filterMode = FilterMode.Point;
				croppedTexture.Apply();
				var copy = Sprite.Create(croppedTexture, new Rect(0f, 0f, (float)croppedTexture.width, (float)croppedTexture.height), 0.5f * Vector2.one, 140f, 0, SpriteMeshType.FullRect);
				NewGameobject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				NewGameobject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				NewGameobject.GetComponent<SpriteRenderer>().sprite = copy;
				NewGameobject.GetComponent<SpriteRenderer>().size = new Vector2(5, 5);
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			else
			{
				NewGameobject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whitespace, new Rect(0f, 0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				NewGameobject.GetComponent<SpriteRenderer>().color = color;
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			NewGameobject.transform.localScale = new Vector2(2533.112f, 2175.462f);
			NewGameobject.transform.parent = null;
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			switch (Type)
			{
				case "Water":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						break;
					}
				case "Acid":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						Water.name = "Acid";
						Water.AddComponent<AcidWater>();
						break;
					}
				case "Lava":
					{
						Map lavaMap = Resources.Load<Map>("Maps/Lava");
						GameObject LavaBefore = lavaMap.Prefab.transform.Find("Lava pool").gameObject;
						var Lava = Instantiate<GameObject>(LavaBefore, Vector3.zero, Quaternion.identity);
						Lava.transform.rotation = Rotation;
						Lava.transform.localScale = new Vector2(Size.x, -Size.y);
						Lava.transform.localPosition = Pos;
						break;
					}
			}
		}

		public static void Main()
		{
			///Don't do anything yet.
			if (MapLoaderBehaviour.CurrentMap.name == MapModName)
			{
				Debug.Log("Setting up some stuff.");
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}
		}
		public static void InitilizeMap()
		{
			foreach (var waterBlock in GameObject.FindObjectsOfType<WaterBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			foreach (var waterBlock in GameObject.FindObjectsOfType<LavaBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			
			CreateGameObjects("Other", new Vector2(14.81122f, 4.968541f), new Vector2(1542f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(47.20694f, 4.964689f), new Vector2(642f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(55.53634f, 2.893639f), new Vector2(67f, 213.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(80.48926f, -0.8290623f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(80.48073f, 4.462146f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(96.166f, 4.463394f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(96.15746f, -0.8291357f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(99.4081f, -0.8374351f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(99.40382f, 4.4521f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(221.4432f, -0.8291318f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(221.4636f, 4.457806f), new Vector2(72f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(88.32353f, 7.719326f), new Vector2(620.9998f, 292.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(160.4351f, 7.707905f), new Vector2(4344f, 292.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(221.9355f, 20.80893f), new Vector2(39f, 626.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(210.5143f, 14.17029f), new Vector2(39f, 160.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(219.5793f, 19.80716f), new Vector2(164f, 277.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(199.2336f, 19.64064f), new Vector2(315f, 160.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(199.7265f, 19.80671f), new Vector2(1143f, 277.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(165.8806f, 19.80722f), new Vector2(1143f, 277.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(152.8242f, 19.80718f), new Vector2(1143f, 277.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(39.80383f, 10.91934f), new Vector2(2802f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(-4.277213f, 10.90655f), new Vector2(198f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(76.20859f, 16.85063f), new Vector2(2886f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(116.867f, 14.78026f), new Vector2(67f, 213.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(125.4376f, 22.79333f), new Vector2(1542f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(65.78131f, 22.79432f), new Vector2(2550f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(-2.638363f, 16.85927f), new Vector2(2550f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(25.69497f, 23.03587f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(25.23554f, 22.58037f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(24.77741f, 22.12225f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(24.32323f, 21.66807f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(23.86379f, 21.20995f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(23.40567f, 20.75314f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(22.94886f, 20.29633f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(22.49205f, 19.83821f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(22.03656f, 19.38009f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(21.57843f, 18.92328f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(21.12031f, 18.46648f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(20.6635f, 18.00967f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(28.39435f, 20.7224f), new Vector2(-177f, 213.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(27.46537f, 20.84871f), new Vector2(-143f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(26.64533f, 20.33465f), new Vector2(-143f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(25.70289f, 19.41669f), new Vector2(-143f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(24.76045f, 18.52321f), new Vector2(-143f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(22.98572f, 17.50733f), new Vector2(-143f, 83.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(23.90449f, 18.33962f), new Vector2(-143f, 86.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(73.12675f, 34.92506f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(73.58784f, 34.47248f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(74.04043f, 34.01565f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(74.4994f, 33.55668f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(74.95198f, 33.09772f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(75.41732f, 32.64089f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(75.87416f, 32.1883f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(76.32887f, 31.72509f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(76.78571f, 31.2725f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(77.24255f, 30.81354f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(77.72752f, 30.35504f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(78.15558f, 29.89472f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(72.67359f, 35.38232f), new Vector2(20f, 19.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(104.1792f, 28.76343f), new Vector2(7926f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(220.2089f, 28.78124f), new Vector2(113f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(81.37379f, 28.54778f), new Vector2(85f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(210.509f, 27.17642f), new Vector2(35f, 92.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(62.01128f, 32.61095f), new Vector2(-738f, 213.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(39.21287f, 34.9136f), new Vector2(775f, 52.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(5.611237f, 32.61015f), new Vector2(-1494f, 213.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(71.06161f, 33.16335f), new Vector2(-162f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(72.18388f, 32.25364f), new Vector2(-143f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(73.09246f, 31.29846f), new Vector2(-143f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(74.02995f, 30.42579f), new Vector2(-143f, 138.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(74.9278f, 29.94965f), new Vector2(-143f, 107.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(75.83926f, 29.56874f), new Vector2(-143f, 73.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(91.06451f, 38.1473f), new Vector2(-692f, 306.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(104.8744f, 34.74944f), new Vector2(775f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(148.38f, 34.73772f), new Vector2(2209f, 68.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(178.2514f, 31.40723f), new Vector2(53f, 213.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(117.6945f, 30.85281f), new Vector2(61f, 213.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(143.8266f, 39.09861f), new Vector2(450f, 175.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(1107.069f, 378.6934f), new Vector2(53333f, 74028.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 2);
                CreateGameObjects("Other", new Vector2(194.0009f, 711.5627f), new Vector2(-46567f, 46833.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(31.00765f, 44.18161f), new Vector2(-3632f, 306.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(114.6132f, 41.00417f), new Vector2(-1532f, 306.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(173.0057f, 41.00286f), new Vector2(-1532f, 306.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(268.654f, 38.82481f), new Vector2(-6152f, 306.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateWaterBlock(new Vector3(290.2f, 7.2f, 1f), new Vector3(201.5022f, 1.947645f, 0f), Quaternion.Euler(0f, 0f, 0f), "Water");
                CreateCustomGameObjects("Custom", new Vector2(211.6603f, 1.892186f), new Vector2(42.6f, 0.5200001f), Quaternion.Euler(0f, 0f, 0f), CustomSprite4, "Front", true, 2);
                CreateCustomGameObjects("Custom", new Vector2(139.1384f, 31.90108f), new Vector2(0.7900002f, 5.650009f), Quaternion.Euler(0f, 0f, 270f), CustomSprite5, "Front", true, 5);
                CreateCustomGameObjects("Custom", new Vector2(161.6508f, 31.20383f), new Vector2(0.7900002f, -4.349991f), Quaternion.Euler(0f, 0f, 270f), CustomSprite5, "Front", true, 5);
                CreateCustomGameObjects("Custom", new Vector2(128.4181f, 39.27032f), new Vector2(-1.51f, 9.450012f), Quaternion.Euler(0f, 0f, 270f), CustomSprite5, "Front", true, 5);
                CreateCustomGameObjects("Custom", new Vector2(164.267f, 39.2718f), new Vector2(-1.51f, -4.549988f), Quaternion.Euler(0f, 0f, 270f), CustomSprite5, "Front", true, 5);
                CreateCustomGameObjects("Custom", new Vector2(340.7364f, 6.085159f), new Vector2(7.79f, -1.349991f), Quaternion.Euler(0f, 0f, 270f), CustomSprite5, "Front", true, 5);
                CreateCustomGameObjects("Custom", new Vector2(264.5069f, 31.44353f), new Vector2(23.56997f, 0.8300092f), Quaternion.Euler(0f, 0f, 180f), CustomSprite5, "Front", true, 5);
                CreateCustomGameObjects("Custom", new Vector2(4.583787f, 27.58032f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(34.55352f, 27.57889f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(89.89796f, 27.58122f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(116.5625f, 27.58067f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(215.2909f, 27.57822f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(214.5547f, 15.63722f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(128.2517f, 21.60743f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(5.596173f, 3.785828f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite6, "Back", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(11.3626f, 3.20456f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateCustomGameObjects("Custom", new Vector2(43.50608f, 3.200627f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateCustomGameObjects("Custom", new Vector2(67.36813f, 9.153962f), new Vector2(1.18f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateCustomGameObjects("Custom", new Vector2(8.463305f, 15.09481f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateCustomGameObjects("Custom", new Vector2(41.27781f, 21.03057f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateCustomGameObjects("Custom", new Vector2(32.92244f, 33.37812f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateCustomGameObjects("Custom", new Vector2(47.11967f, 33.37991f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateGameObjects("Other", new Vector2(34.44226f, 32.04643f), new Vector2(41.94f, 162.0599f), Quaternion.Euler(0f, 0f, 0f), "Front", true, 4);
                CreateGameObjects("Other", new Vector2(44.37415f, 32.00555f), new Vector2(41.94f, 162.0599f), Quaternion.Euler(0f, 0f, 0f), "Front", true, 4);
                CreateCustomGameObjects("Custom", new Vector2(104.7682f, 32.98396f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Back", true, 3);
                CreateCustomGameObjects("Custom", new Vector2(184.0524f, 47.99822f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite8, "Back", true, -200);
                CreateCustomGameObjects("Custom", new Vector2(-3.538903f, 14.91925f), new Vector2(7.79f, 1.650009f), Quaternion.Euler(0f, 0f, 270f), CustomSprite5, "Front", true, 5);
                CreateLightSources("Light", new Vector2(5.586001f, 2.983678f), new Vector2(-1.095981f, 1.127901f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 4f);
                CreateCustomGameObjects("Custom", new Vector2(37.72078f, 36.83818f), new Vector2(13.56997f, 0.8300092f), Quaternion.Euler(0f, 0f, 180f), CustomSprite5, "Front", true, 5);
                CreateParticleSources("Particles", new Vector2(102.8724f, 35.72681f), 1f, "Spark");
                CreateLightSources("Light", new Vector2(4.571693f, 26.99364f), new Vector2(-1.095981f, 1.127901f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 4f);
                CreateLightSources("Light", new Vector2(128.2873f, 20.9857f), new Vector2(-1.095981f, 1.127901f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 4f);
                CreateLightSources("Light", new Vector2(214.4971f, 15.00694f), new Vector2(-1.095981f, 1.127901f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 4f);
                CreateLightSources("Light", new Vector2(215.2379f, 26.82949f), new Vector2(-1.095981f, 1.127901f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255 ,255, 255), 4f);
                CreateCustomGameObjects("Custom", new Vector2(220.5054f, 29.46771f), new Vector2(1f, 0.8580018f), Quaternion.Euler(0f, 0f, 0f), CustomSprite9, "Front", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(54.50307f, 5.671849f), new Vector2(1f, 0.7960026f), Quaternion.Euler(0f, 0f, 0f), CustomSprite9, "Front", true, -1);
                CreateCustomGameObjects("Custom", new Vector2(115.8115f, 17.58948f), new Vector2(1f, 0.8580018f), Quaternion.Euler(0f, 0f, 0f), CustomSprite9, "Front", true, -1);
                
		}
	}
	public class AcidWater : MonoBehaviour
	{
		private void Start()
		{
			SpriteRenderer spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
			spriteRenderer.material.shader = Shader.Find("Sprites/Default");
			spriteRenderer.material.color = new Color(0, 1f, 0.1509f, 0.1819f);
			spriteRenderer.color = new Color(0, 1, 0, 1);
		}
		private void OnTriggerEnter2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<LimbBehaviour>() != null)
			{
				collider2D.gameObject.AddComponent<AcidEffect>();
			}
		}
		private void OnTriggerExit2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<AcidEffect>() != null)
			{
				UnityEngine.Object.Destroy(collider2D.gameObject.GetComponent<AcidEffect>());
			}
		}

	}
	public class AcidEffect : MonoBehaviour
	{
		LimbBehaviour limbBehaviour;
		private void Start()
		{
			limbBehaviour = gameObject.GetComponent<LimbBehaviour>();
		}
		private void Update()
		{
			limbBehaviour.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 0.05f * Time.deltaTime);
		}
	}
	public class MapModManager : MonoBehaviour
	{
		private void Start()
		{
			Mod.InitilizeMap();
		}
	}

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
			{
				Rig.bodyType = RigidbodyType2D.Static;
			}
		}
	}

	public class ParticleDelay : MonoBehaviour
	{
		public string Particles1;
		public float Speed1;
		public void Awake()
		{
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
	}
}

